/** This done as function returning function mainly to workaround deduplication
 * logic in plugin pipeline processor preventing you from having two instances
 * of a plugin.
 */
var index = (function (marker, tagType, classNames, nodeType) {
  if (classNames === void 0) {
    classNames = [];
  }

  if (nodeType === void 0) {
    nodeType = "decoration";
  }

  if (!marker || !tagType) throw "You must specify both marker and tag";
  return function () {
    var Parser = this.Parser.prototype;

    Parser.inlineTokenizers[nodeType] = function underlineTokenizer(eat, value, silent) {
      if (value.startsWith(marker)) {
        var end = value.indexOf(marker, marker.length);

        if (end > -1) {
          if (silent) {
            return true;
          }

          var text = value.substring(marker.length, end);
          var now = eat.now();
          now.column += marker.length;
          now.offset += marker.length;
          return eat(marker + text + marker)({
            type: nodeType,
            children: this.tokenizeInline(text, now),
            data: {
              hName: tagType,
              hProperties: classNames.length ? {
                className: classNames
              } : {}
            }
          });
        }
      }

      return false;
    };

    Parser.inlineTokenizers[nodeType].locator = function (value, fromIndex) {
      return value.indexOf(marker, fromIndex);
    };

    Parser.inlineMethods.splice(Parser.inlineMethods.indexOf("strong"), 0, nodeType);
  };
});

export default index;
//# sourceMappingURL=remark-text-decoration.mjs.map
